#!/usr/bin/perl

print "Content-type:text/html\n\n";

open(FILEIN, "gsdlsite.cfg") or die "Could not open site configuration file\n";
@config=<FILEIN>;
close(FILEIN);

foreach $line (@config)
{
    if($line=~/(gsdlhome)\s+(\S+)/)
    {
	$fileoutloc=$2;
	$fileoutloc =~ s/\"//g;
	if(!($fileoutloc=~ /\/$/)) {$fileoutloc.="/"; }
	$fileoutloc.= "etc/usability.txt";
    } 
    elsif($line=~/(httpimg)\s+(\S+)/)
    {
	$imageloc =$2;
	if(!($2=~/http/)){
	    $imageloc="http://".$ENV{HTTP_HOST}."\/".$2;
	}
    }
}


$idno=$ENV{REMOTE_ADDR};
$idno =~ s/\.//g;
$idno .= time;

if(!($fileoutloc=~/etc\/usability\.txt/))
{
    die "Could not open log file etc/usability.txt\n";
}

print "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\n"; 
print "<html>\n<head>\n<title>Greenstone Usability Thank you!</title>\n";
print "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n";

$ENV{HTTP_USER_AGENT}=~/([^\/]*)\/([0-9]+\.[0-9]+)/;
if(($1 ne "Netscape")||($2 > 4.77)){
    print "<style type=\"text/css\">\n";
    print "\th1 \{font-family: sans-serif; font-size: 20px}\n";
    print "</style>\n"
}


print "<script type=\"text/javascript\">\n";
#print "timeleft=21;\n";
#print "function timerdisplay(){\n";
#print "\tif(eval(document.getElementById != undefined )){\n";
#print "\t\tif(parseInt(timeleft)>0){\n";
#print "\t\t\ttimeleft-=1;\n";
#print "\t\t\ttimeforscreen = timeleft+\' second\';\n";
#print "\t\t\tif(timeleft>1)\{ timeforscreen += \'s\';\}\n";
#print "\t\t\t\tdocument.getElementById(\'timer\').firstChild.nodeValue=timeforscreen;\n";
#print "\t\t\t\tsetTimeout(\'timerdisplay()\',1000);\n";
#print "\t\t}\n";
#print "\t}\n";
#print "}\n";
#print "\n";
print "function viewdetails() {\n";
print "\talert(\"This function is still being researched, please try again later\");\n}\n";
print "</script>";
print "</head><body onLoad=\"if(parseInt(navigator.appVersion)>3)\{window.resizeTo(420,300);\}\" bgcolor=\"#FFFFFF\">\n";
print "<table width=\"400px\"><tr>\n<td><h1>Greenstone Usability - Thank you</h1></td>\n";
print "<td align=\"right\">";
if ($imageloc) { print "<img src=\"$imageloc\/usabbanner.gif\" alt=\"Greenstone koru design\" title=\"Greenstone koru design\">"; }
print "</td>\n</tr></table>";
print "<p><a href=\"http://nzdl2.cs.waikato.ac.nz/cgi-bin/dana/library?a=p&p=Usability\" target=\"_blank\">About</a> &#8226; <a href=\"http://nzdl2.cs.waikato.ac.nz/cgi-bin/dana/library?a=p&p=Privacy\" target=\"_blank\">Privacy</a>";
print "<p>Your comments have been noted.  Thank you for helping us make Greenstone more usable!";
print "<table width=\"400px\"><tr>\n";
print "<td><a href=\"readresults.cgi?$idno\" target=\"_blank\">View report details</a></td>\n";
print "<td><a href=\"http://nzdl2.cs.waikato.ac.nz/dana/gsdl/test.html\" target=\"_blank\">Track report</a></td>";
print "<td align=\"right\"><p><form action=\"\"><input type=\"Button\" value=\"Close Window\" onClick=\"window.close();\"></form></td>\n";
print"</tr></table>\n";


#print "<h2>Your report ID number is: $idno</h2>";
#print "<p>The information has now been sent, thank-you.  The information sent is displayed below.  This window will close automatically after <span id=\"timer\">20 seconds</span>.";
read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
@pairs=split(/&/,$buffer);

foreach $pair (@pairs) {
    ($name, $value) = split(/=/,$pair);
    $value=~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $FORM{$name} = $value;
}



if (-e $fileoutloc){ 
    open FILEOUT, (">>$fileoutloc");
}
else { open FILEOUT, (">$fileoutloc") or print "cannot open file $fileoutloc\n"; }
#print FILEOUT "-------------------------------------\n";
print FILEOUT "report-id := $idno\n";
foreach $key (keys(%FORM)) {
    if($key eq "URL") {
	$url = $FORM{$key};
	$url =~s/\&/\&amp\;/g;
    }
    print FILEOUT "$key := $FORM{$key}\n"; 
}
print FILEOUT "browser-read-by-server :=  $ENV{HTTP_USER_AGENT}\n";
print FILEOUT "browser-ip-no :=  $ENV{REMOTE_ADDR}\n";
print FILEOUT "server-ip-no :=  $ENV{SERVER_ADDR}\n";
print FILEOUT "time := ".scalar(localtime(time))."\n";
print FILEOUT "----------------------------------------------\n";
close (FILEOUT);


print"</body></html>\n"; 

